'use strict';

/**
 * A list of modules to insert into the Container at start up
 *
 * Modules to be loaded with an alias should have an array with the alias
 * then the module name. Otherwise, just a string with the module name
 *
 * @type {array}
 */
module.exports = [
	['_', 'lodash'],
	'path',
	['promisify', 'helpers/promisify'],
];